From e91c81af796fbc7e12ec9994344bfd79320da197 Mon Sep 17 00:00:00 2001
From: Marius Tomaschewski <mt@suse.com>
Date: Fri, 1 Mar 2024 19:04:29 +0100
Subject: [PATCH] interface dependencies fix preview 1 (bsc#1205604)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

- Remove port arrays from bond,team,bridge,ovs-bridge and consistently
  use config and state info attached to the port interface as in rtnetlink(7).
- Cleanup ifcfg parsing, schema configuration and service properties
- Migrate ports in xml config and policies already applied in nanny
- Remove "missed config" generation from finite state machine, which is
  is completed while parsing the config or while xml config migration.
- Issue a warning when "lower" interface (e.g. eth0) config is missed
  while parsing config depending on it (e.g. eth0.42 vlan).
- Resolve ovs master to the effective bridge in config and wickedd
- Implement netif-check-state require checks using system relations
  from wickedd/kernel instead of config relations for ifdown and add
  linkDown and deleteDevice checks to all master and lower references.
- Add a `wicked <ifup|ifdown|ifreload> --dry-run …` option to show the
  system/config interface hierarchies as notice with +/- marked interfaces
  to setup and/or shutdown.

Signed-off-by: Marius Tomaschewski <mt@suse.com>

diff --git a/client/compat.c b/client/compat.c
index 37f92e767..f1134e61a 100644
--- a/client/compat.c
+++ b/client/compat.c
@@ -125,6 +125,8 @@ ni_compat_netdev_new(const char *ifname)
 	compat = xcalloc(1, sizeof(*compat));
 	compat->dev = ni_netdev_new(ifname, 0);
 
+	ni_netdev_port_config_init(&compat->port, NI_IFTYPE_UNKNOWN);
+
 	/* Apply defaults */
 	compat->dhcp4.update = ni_config_addrconf_update(ifname, NI_ADDRCONF_DHCP, AF_INET);
 	compat->dhcp4.recover_lease = TRUE;
@@ -184,6 +186,9 @@ ni_compat_netdev_free(ni_compat_netdev_t *compat)
 	if (compat) {
 		if (compat->dev)
 			ni_netdev_put(compat->dev);
+
+		ni_netdev_port_config_destroy(&compat->port);
+
 		ni_ifworker_control_free(compat->control);
 		ni_var_array_destroy(&compat->scripts);
 		ni_string_free(&compat->firewall.zone);
@@ -200,16 +205,6 @@ ni_compat_netdev_free(ni_compat_netdev_t *compat)
 		ni_string_free(&compat->dhcp6.client_id);
 		ni_dhcp6_prefix_req_list_destroy(&compat->dhcp6.prefix_reqs);
 		ni_string_array_destroy(&compat->dhcp6.request_options);
-		switch(compat->port.type) {
-		case NI_IFTYPE_TEAM:
-			ni_team_port_config_destroy(&compat->port.conf.team);
-			break;
-		case NI_IFTYPE_OVS_BRIDGE:
-			ni_ovs_bridge_port_config_destroy(&compat->port.conf.ovsbr);
-			break;
-		default:
-			break;
-		}
 
 		free(compat);
 	}
@@ -492,11 +487,23 @@ __ni_compat_generate_infiniband(xml_node_t *ifnode, const ni_compat_netdev_t *co
 	return TRUE;
 }
 
+static ni_bool_t
+ni_compat_generate_bonding_port_config(xml_node_t *port, const ni_bonding_port_config_t *config)
+{
+	if (!port || !config)
+		return FALSE;
+
+	if (config->queue_id != -1U)
+		xml_node_new_element("queue-id", port, ni_sprint_uint(config->queue_id));
+
+	return TRUE;
+}
+
 static ni_bool_t
 __ni_compat_generate_bonding(xml_node_t *ifnode, const ni_compat_netdev_t *compat)
 {
 	ni_bonding_t *bond;
-	xml_node_t *child, *snodes, *snode;
+	xml_node_t *child;
 	unsigned int i;
 	int verbose = 0; /* do not suppress defaults */
 
@@ -543,29 +550,14 @@ __ni_compat_generate_bonding(xml_node_t *ifnode, const ni_compat_netdev_t *compa
 			ni_bonding_mii_carrier_detect_name(bond->miimon.carrier_detect));
 	}
 
-	snodes = bond->slaves.count ? xml_node_create(child, "slaves") : NULL;
-	for (i = 0; i < bond->slaves.count; ++i) {
-		ni_bonding_slave_t *slave = bond->slaves.data[i];
-
-		if (!slave || ni_string_empty(slave->device.name))
-			continue;
-
-		snode = xml_node_new("slave", snodes);
-		xml_node_new_element("device", snode, slave->device.name);
-
-		switch (bond->mode) {
-		case NI_BOND_MODE_ACTIVE_BACKUP:
-		case NI_BOND_MODE_BALANCE_TLB:
-		case NI_BOND_MODE_BALANCE_ALB:
-			if (ni_string_eq(bond->primary_slave.name, slave->device.name)) {
-				xml_node_new_element("primary", snode, "true");
-			}
-			if (ni_string_eq(bond->active_slave.name, slave->device.name)) {
-				xml_node_new_element("active", snode, "true");
-			}
-		default:
-			break;
-		}
+	switch (bond->mode) {
+	case NI_BOND_MODE_ACTIVE_BACKUP:
+	case NI_BOND_MODE_BALANCE_TLB:
+	case NI_BOND_MODE_BALANCE_ALB:
+		if (!ni_string_empty(bond->primary_slave.name))
+			xml_node_new_element("primary", child, bond->primary_slave.name);
+	default:
+		break;
 	}
 
 	switch (bond->mode) {
@@ -870,8 +862,10 @@ __ni_compat_generate_team_link_watch(xml_node_t *tnode, const ni_team_link_watch
 }
 
 static ni_bool_t
-__ni_compat_generate_team_port_config(xml_node_t *port, const ni_team_port_config_t *config)
+ni_compat_generate_team_port_config(xml_node_t *port, const ni_team_port_config_t *config)
 {
+	if (!port || !config)
+		return FALSE;
 
 	if (config->queue_id != -1U)
 	     xml_node_new_element("queue_id", port, ni_sprint_uint(config->queue_id));
@@ -891,34 +885,6 @@ __ni_compat_generate_team_port_config(xml_node_t *port, const ni_team_port_confi
 	return TRUE;
 }
 
-static ni_bool_t
-__ni_compat_generate_team_ports(xml_node_t *tnode, const ni_team_port_array_t *array)
-{
-	xml_node_t *ports;
-	unsigned int i;
-
-	if (!array || !tnode)
-		return FALSE;
-
-	if (!array->count)
-		return TRUE;
-
-	ports = xml_node_new("ports", tnode);
-	for (i = 0; i < array->count; i++) {
-		ni_team_port_t *p = array->data[i];
-		xml_node_t *port;
-
-		if (ni_string_empty(p->device.name))
-			continue;
-
-		port = xml_node_new("port", ports);
-		xml_node_new_element("device", port, p->device.name);
-		__ni_compat_generate_team_port_config(port, &p->config);
-	}
-
-	return TRUE;
-}
-
 static ni_bool_t
 ni_compat_generate_team_notify_peers(xml_node_t *parent, const ni_team_t *team)
 {
@@ -994,9 +960,6 @@ __ni_compat_generate_team(xml_node_t *ifnode, const ni_compat_netdev_t *compat)
 	if (!__ni_compat_generate_team_link_watch(tnode, &team->link_watch))
 		return FALSE;
 
-	if (!__ni_compat_generate_team_ports(tnode, &team->ports))
-		return FALSE;
-
 	return TRUE;
 }
 
@@ -1143,28 +1106,11 @@ __ni_compat_generate_ppp(xml_node_t *ifnode, const ni_compat_netdev_t *compat)
 }
 
 static ni_bool_t
-__ni_compat_generate_ovs_bridge_ports(xml_node_t *bnode, const ni_ovs_bridge_port_array_t *array)
+ni_compat_generate_ovs_bridge_port_config(xml_node_t *port, const ni_ovs_bridge_port_config_t *config)
 {
-	xml_node_t *ports;
-	unsigned int i;
-
-	if (!array || !bnode)
+	if (!port || !config)
 		return FALSE;
 
-	if (!array->count)
-		return TRUE;
-
-	ports = xml_node_new("ports", bnode);
-	for (i = 0; i < array->count; i++) {
-		ni_ovs_bridge_port_t *p = array->data[i];
-		xml_node_t *port;
-
-		if (ni_string_empty(p->device.name))
-			continue;
-
-		port = xml_node_new("port", ports);
-		xml_node_new_element("device", port, p->device.name);
-	}
 	return TRUE;
 }
 
@@ -1181,10 +1127,23 @@ __ni_compat_generate_ovs_bridge(xml_node_t *ifnode, const ni_compat_netdev_t *co
 		xml_node_t *vnode = xml_node_new("vlan", bnode);
 		xml_node_new_element("parent", vnode, ovsbr->config.vlan.parent.name);
 		xml_node_new_element_uint("tag", vnode, ovsbr->config.vlan.tag);
-	} /* else? */
-	if (!__ni_compat_generate_ovs_bridge_ports(bnode, &ovsbr->ports))
+	}
+
+	return TRUE;
+}
+
+static ni_bool_t
+ni_compat_generate_bridge_port_config(xml_node_t *port, const ni_bridge_port_config_t *config)
+{
+	if (!port || !config)
 		return FALSE;
 
+	if (config->priority != NI_BRIDGE_VALUE_NOT_SET)
+		xml_node_new_element_uint("priority", port, config->priority);
+
+	if (config->path_cost != NI_BRIDGE_VALUE_NOT_SET)
+		xml_node_new_element_uint("path-cost", port, config->path_cost);
+
 	return TRUE;
 }
 
@@ -1194,8 +1153,6 @@ __ni_compat_generate_bridge(xml_node_t *ifnode, const ni_compat_netdev_t *compat
 	const ni_netdev_t *dev = compat->dev;
 	ni_bridge_t *bridge;
 	xml_node_t *child;
-	xml_node_t *ports;
-	unsigned int i;
 	char *tmp = NULL;
 
 	bridge = ni_netdev_get_bridge(compat->dev);
@@ -1230,24 +1187,6 @@ __ni_compat_generate_bridge(xml_node_t *ifnode, const ni_compat_netdev_t *compat
 		ni_string_free(&tmp);
 	}
 
-	ports = xml_node_new("ports", child);
-	for (i = 0; i < bridge->ports.count; ++i) {
-		const ni_bridge_port_t *port = bridge->ports.data[i];
-		xml_node_t *portnode = xml_node_new("port", ports);
-
-		xml_node_new_element("device", portnode, port->ifname);
-		if (port->priority != NI_BRIDGE_VALUE_NOT_SET &&
-		    ni_string_printf(&tmp, "%u", port->priority)) {
-			xml_node_new_element("priority", portnode, tmp);
-			ni_string_free(&tmp);
-		}
-		if (port->path_cost != NI_BRIDGE_VALUE_NOT_SET &&
-		    ni_string_printf(&tmp, "%u", port->path_cost)) {
-			xml_node_new_element("path-cost", portnode, tmp);
-			ni_string_free(&tmp);
-		}
-	}
-
 	if (dev->link.hwaddr.len) {
 		xml_node_new_element("address", child,
 			ni_link_address_print(&dev->link.hwaddr));
@@ -3003,11 +2942,17 @@ ni_compat_generate_ifnode_content(xml_node_t *ifnode, const ni_compat_netdev_t *
 			xml_node_add_attr(port, "type", ni_linktype_type_to_name(compat->port.type));
 
 			switch(compat->port.type) {
-			case NI_IFTYPE_OVS_BRIDGE:
-				xml_node_new_element("bridge", port, compat->port.conf.ovsbr.bridge.name);
+			case NI_IFTYPE_BOND:
+				ni_compat_generate_bonding_port_config(port, compat->port.bond);
 				break;
 			case NI_IFTYPE_TEAM:
-				__ni_compat_generate_team_port_config(port, &compat->port.conf.team);
+				ni_compat_generate_team_port_config(port, compat->port.team);
+				break;
+			case NI_IFTYPE_BRIDGE:
+				ni_compat_generate_bridge_port_config(port, compat->port.bridge);
+				break;
+			case NI_IFTYPE_OVS_BRIDGE:
+				ni_compat_generate_ovs_bridge_port_config(port, compat->port.ovsbr);
 				break;
 			default:
 				break;
@@ -3075,25 +3020,93 @@ ni_compat_generate_interface(xml_document_t *doc, const ni_compat_netdev_t *comp
 	return NULL;
 }
 
+static ni_bool_t
+ni_compat_generate_policy_match_device(xml_node_t *match,
+		const ni_compat_netdev_t *compat)
+{
+	const char *name = compat->dev->name;
+
+	/*
+	 * Generate <device>${name}</device> match (self reference) node.
+	 */
+	if (!match || ni_string_empty(name))
+		return FALSE;
+
+	if (xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, match, name))
+		return TRUE;
+
+	return FALSE;
+}
+
+static ni_bool_t
+ni_compat_generate_policy_match_device_ref(xml_node_t *match,
+		const char *name)
+{
+	xml_node_t *ref;
+
+	/*
+	 * Generate <reference><device>${name}</device></reference>
+	 * match node to a related (lower, master, …) interface.
+	 */
+	if (!match || ni_string_empty(name))
+		return FALSE;
+
+	if (!(ref = xml_node_new(NI_NANNY_IFPOLICY_MATCH_REF, match)))
+		return FALSE;
+
+	if (xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, ref, name))
+		return TRUE;
+
+	xml_node_detach(ref);
+	xml_node_free(ref);
+	return FALSE;
+}
+
+static ni_bool_t
+ni_compat_generate_policy_match_lower_ref(xml_node_t *match,
+		const ni_compat_netdev_t *compat)
+{
+	const char *name = compat->dev->link.lowerdev.name;
+
+	/* only some interfaces use lower */
+	if (ni_string_empty(name))
+		return TRUE;
+
+	return ni_compat_generate_policy_match_device_ref(match, name);
+}
+
+static ni_bool_t
+ni_compat_generate_policy_match_master_ref(xml_node_t *match,
+		const ni_compat_netdev_t *compat)
+{
+	const char *name = compat->dev->link.masterdev.name;
+
+	/* not being a port is not an error */
+	if (ni_string_empty(name))
+		return TRUE;
+
+	return ni_compat_generate_policy_match_device_ref(match, name);
+}
+
 static ni_bool_t
 ni_compat_generate_policy_match(xml_node_t *match, const ni_compat_netdev_t *compat)
 {
 	ni_netdev_t *dev = compat->dev;
 
-	ni_trace(" - generate policy match for %s: type=%s, master=%s, lower=%s",
+	ni_debug_application("  - generate policy match for %s: type=%s, master=%s, lower=%s",
 			dev->name, ni_linktype_type_to_name(dev->link.type),
 			dev->link.masterdev.name, dev->link.lowerdev.name);
 
-	/* properties we want to match */
+	if (!ni_compat_generate_policy_match_device(match, compat))
+		return FALSE;
 
-#if 0	/* TODO: */
-	if (compat->identify.hwaddr.len &&
-	    compat->identify.hwaddr.type == ARPHRD_ETHER) {
-		/* TODO */
-	} /* else */
-#endif
-	if (!ni_string_empty(compat->dev->name))
-		xml_node_new_element(NI_NANNY_IFPOLICY_MATCH_DEV, match, compat->dev->name);
+	/* link's reference to lower device */
+	if (!ni_compat_generate_policy_match_lower_ref(match, compat))
+		return FALSE;
+
+	/* port's reference to a master device */
+	if (!ni_compat_generate_policy_match_master_ref(match, compat))
+		return FALSE;
 
 	return TRUE;
 }
@@ -3103,7 +3116,7 @@ ni_compat_generate_policy_action(xml_node_t *action, const ni_compat_netdev_t *c
 {
 	ni_netdev_t *dev = compat->dev;
 
-	ni_trace(" - generate policy action %s for %s: type=%s, master=%s, lower=%s",
+	ni_debug_application("  - generate policy action %s for %s: type=%s, master=%s, lower=%s",
 			action->name,
 			dev->name, ni_linktype_type_to_name(dev->link.type),
 			dev->link.masterdev.name, dev->link.lowerdev.name);
@@ -3135,7 +3148,8 @@ ni_compat_generate_policy(xml_document_t *doc, const ni_compat_netdev_t *compat,
 	else
 		pname = ni_ifpolicy_name_from_ifname(compat->dev->name);
 
-	ni_trace("* generate policy[%u] for %s: name=%s", nr, compat->dev->name, pname);
+	ni_debug_application("* generate policy[%u] for %s: name=%s",
+			nr, compat->dev->name, pname);
 	xml_node_add_attr(ifpolicy, NI_NANNY_IFPOLICY_NAME, pname);
 	ni_string_free(&pname);
 
@@ -3193,23 +3207,25 @@ ni_compat_generate_interfaces(xml_document_array_t *array, ni_compat_ifconfig_t
 		if (ni_string_empty(conf->origin))
 			ni_string_dup(&conf->origin, ifcfg->schema);
 
-		xml_node_location_relocate(root, conf->origin);
-		if (!xml_node_location_filename(root))
+		if (ni_string_empty(conf->origin))
 			goto cleanup;
 
 		if (!ni_compat_generate_interface(doc, compat))
 			goto cleanup;
 
+		xml_node_location_relocate(root, conf->origin);
 		if (!raw)
 			ni_ifconfig_metadata_add_to_node(root, conf);
 
 		if (ni_ifconfig_validate_adding_doc(doc, check_prio)) {
 			ni_debug_ifconfig("%s: %s", __func__, xml_node_location(root));
-			xml_document_array_append(array, doc);
-		} else {
-	cleanup:
-			xml_document_free(doc);
+
+			if (xml_document_expand(array, doc))
+				continue;
 		}
+
+	cleanup:
+		xml_document_free(doc);
 	}
 
 	return count - array->count;
@@ -3243,23 +3259,25 @@ ni_compat_generate_policies(xml_document_array_t *array, ni_compat_ifconfig_t *i
 		if (ni_string_empty(conf->origin))
 			ni_string_dup(&conf->origin, ifcfg->schema);
 
-		xml_node_location_relocate(root, conf->origin);
-		if (!xml_node_location_filename(root))
+		if (ni_string_empty(conf->origin))
 			goto cleanup;
 
 		if (!ni_compat_generate_policy(doc, compat, array->count + 1))
 			goto cleanup;
 
+		xml_node_location_relocate(root, conf->origin);
 		if (!raw)
 			ni_ifconfig_metadata_add_to_node(root, conf);
 
 		if (ni_ifconfig_validate_adding_doc(doc, check_prio)) {
 			ni_debug_ifconfig("%s: %s", __func__, xml_node_location(root));
-			xml_document_array_append(array, doc);
-		} else {
-	cleanup:
-			xml_document_free(doc);
+
+			if (xml_document_expand(array, doc))
+				continue;
 		}
+
+	cleanup:
+		xml_document_free(doc);
 	}
 
 	return count - array->count;
diff --git a/client/convert.c b/client/convert.c
index eb16c926f..026f54faf 100644
--- a/client/convert.c
+++ b/client/convert.c
@@ -161,7 +161,11 @@ ni_wicked_convert_dump(xml_document_array_t *docs, ni_string_array_t *filter, FI
 		if (xml_node_is_empty(root))
 			continue;
 
-		for (node = root->children; node; node = node->next) {
+		if (ni_string_empty(root->name))
+			node = root->children;
+		else
+			node = root;
+		for (; node; node = node->next) {
 			if (!ni_wicked_convert_match(node, filter))
 				continue;
 
@@ -204,7 +208,11 @@ ni_wicked_convert_to_dir(xml_document_array_t *docs, ni_string_array_t *filter,
 		if (xml_node_is_empty(root))
 			continue;
 
-		for (node = root->children; node; node = node->next) {
+		if (ni_string_empty(root->name))
+			node = root->children;
+		else
+			node = root;
+		for (; node; node = node->next) {
 			if (!ni_wicked_convert_match(node, filter))
 				continue;
 
@@ -429,6 +437,9 @@ ni_wicked_convert(const char *caller, int argc, char **argv)
 		}
 	}
 
+	if (ni_ifxml_migrate_docs(&docs))
+		ni_debug_readwrite("Migrated configuration to current schema");
+
 	if (opt_output == NULL || ni_string_eq(opt_output, "-")) {
 		ni_wicked_convert_dump(&docs, &filter, stdout);
 	} else
diff --git a/client/dracut/cmdline.c b/client/dracut/cmdline.c
index faa34fa85..5557d1378 100644
--- a/client/dracut/cmdline.c
+++ b/client/dracut/cmdline.c
@@ -1133,8 +1133,6 @@ ni_ifconfig_read_dracut_cmdline(xml_document_array_t *array,
 	xml_document_t *doc;
 	xml_node_t *options;
 
-	doc = xml_document_new();
-
 	/*
 	 * expose config parser specific "meta options"
 	 * to the caller in order to:
@@ -1144,9 +1142,19 @@ ni_ifconfig_read_dracut_cmdline(xml_document_array_t *array,
 	 *   do not result in any ifcomfig/ifpolicy
 	 *   but may be needed in e.g. in bootstrap
 	 */
-	options = xml_node_new("options", xml_document_root(doc));
+	if (!(options = xml_node_new("options", NULL)))
+		return FALSE;
+
 	xml_node_add_attr(options, "origin", "dracut:cmdline:");
-	xml_document_array_append(array, doc);
+	if (!(doc = xml_document_create(NULL, options))) {
+		xml_node_free(options);
+		return FALSE;
+	}
+	xml_node_location_relocate(doc->root, "<dracut:cmdline>");
+	if (!xml_document_array_append(array, doc)) {
+		xml_document_free(doc);
+		return FALSE;
+	}
 
 	if (ni_dracut_cmdline_file_parse(&params, path)) {
 		/*
diff --git a/client/ifcheck.c b/client/ifcheck.c
index e06c4ba13..627b6cedf 100644
--- a/client/ifcheck.c
+++ b/client/ifcheck.c
@@ -90,8 +90,6 @@ ni_ifcheck_device_link_required(ni_netdev_t *dev)
 
 	if (cs && ni_tristate_is_set(cs->control.require_link))
 		link_required = cs->control.require_link;
-	else if (dev)
-		link_required = ni_netdev_guess_link_required(dev);
 
 	return !ni_tristate_is_disabled(link_required);
 }
@@ -121,8 +119,6 @@ ni_ifcheck_worker_device_link_required(ni_ifworker_t *w)
 
 	if (w && ni_tristate_is_set(w->control.link_required))
 		link_required = w->control.link_required;
-	else if (w && w->device)
-		link_required = ni_netdev_guess_link_required(w->device);
 
 	return !ni_tristate_is_disabled(link_required);
 }
diff --git a/client/ifdown.c b/client/ifdown.c
index b80a3a0d2..5e2d3f03b 100644
--- a/client/ifdown.c
+++ b/client/ifdown.c
@@ -107,7 +107,8 @@ int
 ni_do_ifdown(int argc, char **argv)
 {
 	enum  { OPT_HELP, OPT_FORCE, OPT_DELETE, OPT_NO_DELETE, OPT_TIMEOUT,
-		OPT_RELEASE, OPT_NO_RELEASE	};
+		OPT_RELEASE, OPT_NO_RELEASE, OPT_DRY_RUN,
+	};
 	static struct option ifdown_options[] = {
 		{ "help",	no_argument, NULL,		OPT_HELP },
 		{ "force",	required_argument, NULL,	OPT_FORCE },
@@ -116,6 +117,8 @@ ni_do_ifdown(int argc, char **argv)
 		{ "release",	no_argument, NULL,		OPT_RELEASE },
 		{ "no-release",	no_argument, NULL,		OPT_NO_RELEASE },
 		{ "timeout",	required_argument, NULL,	OPT_TIMEOUT },
+		{ "dry-run",	no_argument, NULL,		OPT_DRY_RUN },
+
 		{ NULL }
 	};
 	ni_ifmatcher_t ifmatch;
@@ -126,6 +129,7 @@ ni_do_ifdown(int argc, char **argv)
 	unsigned int seconds = NI_IFWORKER_DEFAULT_TIMEOUT;
 	ni_stringbuf_t sb = NI_STRINGBUF_INIT_DYNAMIC;
 	ni_tristate_t opt_release = NI_TRISTATE_DEFAULT;
+	ni_log_fn_t *dry_run = NULL;
 	ni_fsm_t *fsm;
 	int c, status = NI_WICKED_RC_USAGE;
 
@@ -188,6 +192,10 @@ ni_do_ifdown(int argc, char **argv)
 			}
 			break;
 
+		case OPT_DRY_RUN:
+			dry_run = ni_note;
+			break;
+
 		default:
 		case OPT_HELP:
 usage:
@@ -207,8 +215,10 @@ usage:
 				"  --[no-]release\n"
 				"      Override active config to (not) release leases\n"
 				"  --timeout <sec>\n"
-				"      Timeout after <sec> seconds\n",
-				sb.string
+				"      Timeout after <sec> seconds\n"
+				"  --dry-run\n"
+				"      Show system interface hierarchy as notice with (-) markers and exit.\n"
+				, sb.string
 				);
 			ni_stringbuf_destroy(&sb);
 			return status;
@@ -242,11 +252,19 @@ usage:
 		return NI_WICKED_RC_ERROR;
 	}
 
+	if (ni_fsm_build_hierarchy(fsm, FALSE) < 0) {
+		ni_error("ifdown: unable to build interface hierarchy");
+		status = NI_WICKED_RC_ERROR;
+		goto cleanup;
+	}
+
 	/* Get workers that match given criteria */
+	status = NI_WICKED_RC_SUCCESS;
 	nmarked = 0;
 	while (optind < argc) {
 		ifmatch.name = argv[optind++];
 		ifmatch.ifdown = TRUE;
+
 		ni_fsm_get_matching_workers(fsm, &ifmatch, &ifmarked);
 
 		if (ni_string_eq(ifmatch.name, "all") ||
@@ -259,6 +277,10 @@ usage:
 			ni_string_array_append(&ifnames, ifmatch.name);
 	}
 
+	ni_fsm_print_system_hierarchy(fsm, &ifmarked, dry_run);
+	if (dry_run)
+		goto cleanup;
+
 	/* Mark and start selected workers */
 	if (ifmarked.count) {
 		/* Disable devices and delete all related policies from nanny */
@@ -289,6 +311,7 @@ usage:
 		status = ni_ifstatus_shutdown_result(fsm, &ifnames, &ifmarked);
 	}
 
+cleanup:
 	ni_string_array_destroy(&ifnames);
 	ni_ifworker_array_destroy(&ifmarked);
 	ni_fsm_free(fsm);
